//  //  SOME PROCEDURAL PATTERN- GENERATORS  //  //
float PatChecker(vec2 uvs,  float countX, float countY ){
    return mod( floor( countX * uvs.x) + floor( countY * uvs.y), 2.0);
}
float PatGradSaw( float uvAxis, float count){
	return fract( count * uvAxis);
}
float PatGradSawMirr( float uvAxis, float count){
	return abs( fract( count * uvAxis)* 2.0 - 1.0);
}
float PatSinWave( float uvX, float uvY, float count ){
	return smoothstep(0.0, 0.06, 0.2 - 0.1 * sin( count * uvX) - uvY);
}
float PatDots( vec2 uvs, float count, float size){
	return smoothstep( size , size + 0.425, length( fract( count * uvs) - 0.5));
}
float PatBricks( vec2 uvs, float size, float gap, float smoothness){
	return smoothstep(0.54-gap-smoothness,0.54-gap,
           max(abs(fract(size*uvs.x-0.5*mod(floor(size*uvs.y),2.0))-0.5),
           abs(fract(size*uvs.y)-0.5)));
}
float panX( float uvx, float speed){
    return uvx + iTime * speed;
}
float panY( float uvy, float speed){
    return uvy + iTime * speed;
}

//  // MAIN SHADER  //  //
void mainImage( out vec4 fragColor, in vec2 fragCoord ){
	vec2 uv = fragCoord.xy / iResolution.xy;
    uv.x = uv.x * ( iResolution.x / iResolution.y);
    float bricks = PatBricks( vec2( uv.x + iTime / 10.0, uv.y - iTime / 10.0), 2.0, 0.001, 1.0);
    float bricks2 = PatBricks( vec2( -uv.x + iTime / 24.0, -uv.y + iTime / 36.0), 32.0, 0.1, 0.95);
    bricks = bricks * 1.5 * bricks2 - bricks2;
    bricks = clamp( pow( bricks, 1.5),0.0,1.0);
    bricks /= 60.0;
    float waves = 1.0 - PatDots( vec2( uv.x+bricks, panY( uv.y+bricks, 0.1)), 1.68, 0.35);
    float waves2 = ( 1.0 - PatSinWave( panX( -uv.x , 0.18), abs ( uv.y / 1.3  - 0.31 - waves / 12.0) , 3.2 ));
    float waves3 = PatGradSawMirr( panX( uv.x - pow((waves2 - waves)/ 4.0, 0.2) , 0.25 ), 0.5);
    float result = abs ( ( waves * waves2) / waves2 * waves3 * (waves2 + waves3)) / 4.0;
	float red = pow( result, 1.8 + 0.6 * cos (iTime)- waves );
    float green = result * 1.8 + 0.6 * sin (iTime)* waves2 * result;
    float blue = pow( result, 0.6 + sin (iTime)* result* -waves2 );
    fragColor = vec4( red, green, blue, 1.0);
}
